## promod3 3.6.0+ds

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Author: Bienchen
#-------------------------------------------------------------------------------
# Options to CMake:
#    DISABLE_DOCUMENTATION: Don't build documentation, don't search for Sphinx
#    DISABLE_DOCTEST: Don't run example code from documentation on 'make check'
#    DISABLE_LINKCHECK: Don't test links from documentation on 'make check'
# (if documentation is disabled, there is no doctest, linkcheck at all)
cmake_minimum_required(VERSION 3.22 FATAL_ERROR)

# Set CMake policies
# Behaviour of target_link_libraries, always link by full path. CMP0060 can
# disable this to stay compatible with old projects. We want the new behaviour
# since before we needed to provide the full path ourselves, that is: we
# manually forced CMake to the new scheme.
cmake_policy(SET CMP0060 NEW)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.31.0")
  # See CMP0177 for more information
  # To summarize: all paths given to the install command are normalized starting
  # from cmake version 3.31. Starting from 3.31 you'll start to see warnings if
  # you use the OLD behaviour but some paths would need normalization.
  # The problem with ost: some of the paths that we give install look like:
  # xyz/./bla. So its actually a good thing to run them through normalization
  # which would give xyz/bla
  cmake_policy(SET CMP0177 NEW)
endif()

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.30.0")
  # See CMP0167 for more information
  # to summarize: Starting from boost 1.70, boost comes with a package
  # configuration file BoostConfig.cmake. Starting from cmake 3.30,
  # this is the way to go and users get warned if the old FindBoost module
  # gets used.
  cmake_policy(SET CMP0167 NEW)
endif()



set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake_support)
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

project(ProMod3 CXX C)

include(PROMOD3)

# versioning info
set(PROMOD3_VERSION_MAJOR 3)
set(PROMOD3_VERSION_MINOR 6)
set(PROMOD3_VERSION_PATCH 0)
set(PROMOD3_VERSION_STRING ${PROMOD3_VERSION_MAJOR}.${PROMOD3_VERSION_MINOR})
set(PROMOD3_VERSION_STRING ${PROMOD3_VERSION_STRING}.${PROMOD3_VERSION_PATCH})

option(DISABLE_DOCUMENTATION "Do not build documentation" OFF)
option(DISABLE_DOCTEST "Do not check examples in documentation" OFF)
option(DISABLE_LINKCHECK "Do not check links in the documentation" OFF)

# get git info: current working branch
execute_process(
  COMMAND git rev-parse --abbrev-ref HEAD
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_BRANCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

# get git info: latest abbreviated commit hash of the working branch
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_COMMIT_HASH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

# set PM3_RUNTIME_PROFILING_LEVEL
if(NOT PM3_RUNTIME_PROFILING_LEVEL)
  set(PM3_RUNTIME_PROFILING_LEVEL 0)
endif()

if(OPTIMIZE)
  set(CMAKE_BUILD_TYPE Release)
  set(_OPT ON)
else()
   set(CMAKE_BUILD_TYPE Debug)
   set(_OPT OFF)
endif()

if(ENABLE_SSE)
  set(_ENABLE_SSE 1)
else()
  set(_ENABLE_SSE 0)
endif()

setup_stage()
file(MAKE_DIRECTORY ${STAGE_DIR}
     ${EXECUTABLE_OUTPUT_PATH}
     ${HEADER_STAGE_PATH}
     ${LIB_STAGE_PATH}
     ${LIBEXEC_STAGE_PATH})

setup_compiler_flags()

# Python needed before Boost
find_package(Python 3.6 REQUIRED COMPONENTS Interpreter Development)
# Split version string
string(REPLACE "." ";" _python_version_list ${Python_VERSION})
list(GET _python_version_list 0 Python_VERSION_MAJOR)
list(GET _python_version_list 1 Python_VERSION_MINOR)
# where Python modules live
set(PYTHON_MODULE_PATH "python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")

set(_BOOST_MIN_VERSION 1.70)

if(BOOST_VERSION)
  message(STATUS "forcing boost to version ${BOOST_VERSION}")
  set(_BOOST_MIN_VERSION ${BOOST_VERSION})
endif()
find_package(Boost ${_BOOST_MIN_VERSION}
             COMPONENTS unit_test_framework
                        filesystem
                        iostreams
                        python
             REQUIRED)

if(NOT DISABLE_DOCUMENTATION)
  find_package(Sphinx REQUIRED)
  set(PYTHON_DOC_URL "https://docs.python.org/${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}")
  # this URL should always point to the latest version of OST
  set(OST_DOC_URL "https://www.openstructure.org/docs")
endif()
find_package(OPENSTRUCTURE 2.11.1 REQUIRED
             COMPONENTS io mol seq seq_alg mol_alg conop img mol_mm)

if(CMAKE_COMPILER_IS_GNUCXX)
  # do not write back into cache, otherwise the compile command line gets
  # expanded with multiple -fno-strict-aliasing flags, triggering a complete
  # rebuild whenever cmake is run
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-strict-aliasing")
  if("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes")
  endif("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
endif()

# additional packages/ headers/ etc.
#  Eigen3 is mandatory right now but may vanish once OST switches to the same
#  version.
find_package(Eigen3 3.3.0 REQUIRED)
if(NOT EIGEN3_FOUND)
  message(FATAL_ERROR "Eigen3 is essential for building ${PROJECT_NAME}.")
endif()

# basic environment
include_directories(${Boost_INCLUDE_DIRS}
                    ${OST_INCLUDE_DIR}
                    ${EIGEN3_INCLUDE_DIR})

set(FILES_TO_BE_REMOVED ${PROJECT_BINARY_DIR}/stage)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                             "${FILES_TO_BE_REMOVED}")

## sub dirs to be recognised by CMake
## e.g. add_subdirectory(src), subdirs have their own CMakeLists.txt
add_subdirectory(config)
add_subdirectory(core)
add_subdirectory(loop)
add_subdirectory(scoring)
add_subdirectory(sidechain)
add_subdirectory(modelling)
add_subdirectory(scripts)
add_subdirectory(actions)
add_subdirectory(extras)
add_subdirectory(cmake_support)
if(NOT DISABLE_DOCUMENTATION)
  add_changelog_to_doc(FILE "${CMAKE_CURRENT_SOURCE_DIR}/CHANGELOG")
  add_license_to_doc(FILE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
  add_subdirectory(doc)
endif()

STRING(REGEX REPLACE "^\\\\+\"" "" occp ${OST_COMPOUNDS_CHEMLIB_PATH})
STRING(REGEX REPLACE "\\\\+\"$" "" occp ${occp})

## report setup
message(STATUS "${PROJECT_NAME} will be built with the following options:\n"
        "   OpenStructure (-DOST_ROOT)       : ${OST_ROOT}\n"
        "   Compound library (-DCOMPOUND_LIB): ${occp}\n"
        "   Optimized     (-DOPTIMIZE)       : ${_OPT}\n"
        "   Python                           : ${Python_EXECUTABLE}\n"
        "   Eigen3                           : ${EIGEN3_INCLUDE_DIR}\n")

=== actions/CMakeLists.txt ===
add_custom_target(actions ALL)
add_subdirectory(doc)
add_subdirectory(tests)

pm_action_init()
pm_action(pm-build-model actions)
pm_action(pm-build-rawmodel actions)
pm_action(pm-help actions)
pm_action(pm-build-sidechains actions)

=== doc/CMakeLists.txt ===
# preparing sphinx build
# - setup directories: sources go to BUILD/doc/source
# - every module gets its own directory
# - rst files are copied to this spot
# - compiled documentation goes to STAGE/share/promod3

# list of addtional rst files maintained by the doc dir,
set(_DOC_RST_FILES
index.rst
developers.rst
dev_setup.rst
users.rst
buildsystem.rst
contributing.rst
user_contributions.rst
gettingstarted.rst
portableIO.rst
references.rst
license.rst
)

add_subdirectory(container)

# add documentation tests (must be done before rest below!)
add_custom_target(doctest)
add_subdirectory(tests)

# set up commands/ vars/ ... for the rst source files
set(_RST_DEPS)
set(_DOC_MODULE_DEPS)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_BINARY_DIR}/source" _RST_SOURCE_DIR)
file(MAKE_DIRECTORY ${_RST_SOURCE_DIR})
# take care of Sphinx config, conf.py; will be created from conf.py.in since
# some values from CMake have to be substituted
set(_SPHINX_CONF_PY "${_RST_SOURCE_DIR}/conf.py")
set(_SPHINX_CONF_SUBST_DICT PROMOD3_VERSION_MAJOR="${PROMOD3_VERSION_MAJOR}"
                            PROMOD3_VERSION_MINOR="${PROMOD3_VERSION_MINOR}"
                            PROMOD3_VERSION_PATCH="${PROMOD3_VERSION_PATCH}"
                            PYTHON_DOC_URL="${PYTHON_DOC_URL}"
                            LIB_STAGE_PATH="${LIB_STAGE_PATH}"
                            PYTHON_MODULE_PATH="${PYTHON_MODULE_PATH}"
                            OST_PYMOD_PATH="${OST_PYMOD_PATH}"
                            OST_DOC_URL="${OST_DOC_URL}"
                            LIB_DIR="${LIB_DIR}"
                            THIS_DIR="${_RST_SOURCE_DIR}"
                            PROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}")

set(_CONF_SUBST_DICT -DINPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in)
list(APPEND _CONF_SUBST_DICT -DOUT_FILE=${_SPHINX_CONF_PY})

foreach(_subst ${_SPHINX_CONF_SUBST_DICT})
  list(APPEND _CONF_SUBST_DICT -D${_subst})
endforeach()
add_custom_command(OUTPUT ${_SPHINX_CONF_PY}
                   MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/CMakeLists.txt"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in"
                   COMMAND ${CMAKE_COMMAND} ${_CONF_SUBST_DICT}
                   -P ${CMAKE_SOURCE_DIR}/cmake_support/substitute.cmake)
# also move cmake domain (cmake.py) to the dir to build doc
file(TO_NATIVE_PATH "${_RST_SOURCE_DIR}/cmake.py" _SPHINX_DOMAIN_CMAKE_PY)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake.py" _CSD_SPHINX_DOMAIN_CMAKE_PY)
add_custom_command(OUTPUT ${_SPHINX_DOMAIN_CMAKE_PY}
                   MAIN_DEPENDENCY "${_CSD_SPHINX_DOMAIN_CMAKE_PY}"
                   COMMAND ${CMAKE_COMMAND} -E copy
                  "${_CSD_SPHINX_DOMAIN_CMAKE_PY}" "${_SPHINX_DOMAIN_CMAKE_PY}")
set(_RST_DEPS ${_RST_DEPS} "${_SPHINX_DOMAIN_CMAKE_PY}")
# the reStructuredText files from the doc directory have to be moved to the
# build dir to work with SPHINX
foreach(_rst_file ${_DOC_RST_FILES})
  add_custom_command(OUTPUT "${_RST_SOURCE_DIR}/${_rst_file}"
                     MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/${_rst_file}"
                     COMMAND ${CMAKE_COMMAND} -E copy
   "${CMAKE_CURRENT_SOURCE_DIR}/${_rst_file}" "${_RST_SOURCE_DIR}/${_rst_file}")
  set(_RST_DEPS ${_RST_DEPS} "${_RST_SOURCE_DIR}/${_rst_file}")
endforeach()
# care for a changelog file, if given
if(DEFINED PM3_DOC_CHANGELOG)
  # copy to different file name
  add_custom_command(OUTPUT "${_RST_SOURCE_DIR}/changelog.rst"
                     MAIN_DEPENDENCY "${PM3_DOC_CHANGELOG}"
                     COMMAND ${CMAKE_COMMAND} -E copy
                      "${PM3_DOC_CHANGELOG}" "${_RST_SOURCE_DIR}/changelog.rst")
  set(_RST_DEPS ${_RST_DEPS} "${_RST_SOURCE_DIR}/changelog.rst")
endif()

if(DEFINED PM3_DOC_LICENSE)
  # copy to different file name
  add_custom_command(OUTPUT "${_RST_SOURCE_DIR}/license.txt"
                     MAIN_DEPENDENCY "${PM3_DOC_LICENSE}"
                     COMMAND ${CMAKE_COMMAND} -E copy
                      "${PM3_DOC_LICENSE}" "${_RST_SOURCE_DIR}/license.txt")
  set(_RST_DEPS ${_RST_DEPS} "${_RST_SOURCE_DIR}/license.txt")
endif()

# iterate list of ALL modules registered by pymod()/ add_doc_source()
foreach(mod ${PM3_PY_MS})
  # only modules with dedicated rst files are considered for documentation, so
  # we check if a list PM3_RST_{module name} exists (filled by add_doc_source()
  # the following sets up copying for *.rst files only
  if(DEFINED PM3_RST_${mod})
    # this is a list of rst files, of which everyone becomes a Make target
    foreach(rst ${PM3_RST_${mod}})
      # the list comes with full path, the targets point towards the build dir
      # so we need to extract the filename
      get_filename_component(rst_name ${rst} NAME)
      set(_RST_SOURCE_MOD_DIR "${_RST_SOURCE_DIR}/${mod}")
      # create directory, since it does not come with any CMake file, it will   
      # not be created by CMake
      file(MAKE_DIRECTORY ${_RST_SOURCE_MOD_DIR})
      set(_RST_OUTPUT "${_RST_SOURCE_MOD_DIR}/${rst_name}")
      add_custom_command(OUTPUT "${_RST_OUTPUT}"
                         MAIN_DEPENDENCY "${rst}"
                         DEPENDS ${PM3_DOC_DEPS_${mod}}
                         COMMAND ${CMAKE_COMMAND} -E copy ${rst} ${_RST_OUTPUT})
      # for other targets, create a list of all modules doc depends on
      foreach(md ${PM3_DOC_DEPS_${mod}})
        list(FIND _DOC_MODULE_DEPS ${md} _check_red)
        if("${_check_red}" MATCHES "-1")
          list(APPEND _DOC_MODULE_DEPS "${md}")
        endif()
      endforeach()
      # we need a list of dependencies to create the effective targets, since
      # in our custom_commands we are dealing with file targets
      set(_RST_DEPS ${_RST_DEPS} ${_RST_OUTPUT})
    endforeach()
  endif()
endforeach()

# add dependencies from doctests
list(APPEND _DOC_MODULE_DEPS "${PM3_DOC_DEPS_doctests}")
# ensure that we wait for all modules to be done (solves parallel compile issue)
# -> since this is a custom target, it will not trigger a rebuild
# -> this is intended as rebuild is only needed for files in _DOC_MODULE_DEPS
add_custom_target(doc_wait_for_modules DEPENDS ${PM3_PYMODULES})
# add custom target also for all custom commands (solves parallel compile issue)
# -> https://samthursfield.wordpress.com/2015/11/21/cmake-dependencies-between-targets-and-files-and-custom-commands/
add_custom_target(doc_wait_for_rst DEPENDS "${_SPHINX_CONF_PY}" ${_RST_DEPS})

# create targets for sphinx
# for the html target, we make everything depend on index.html
set(_SPHINX_HTML_DIR "${SHARED_DATA_PATH}/html")
file(MAKE_DIRECTORY ${_SPHINX_HTML_DIR})
set(_SPHINX_INDEX_HTML "${_SPHINX_HTML_DIR}/index.html")
add_custom_command(OUTPUT ${_SPHINX_INDEX_HTML}
                   DEPENDS doc_wait_for_rst "${_SPHINX_CONF_PY}" ${_RST_DEPS}
                           ${_DOC_MODULE_DEPS} doc_wait_for_modules
                   COMMAND "${Python_EXECUTABLE}" -m sphinx -b html -c "${_RST_SOURCE_DIR}"
                                     "${_RST_SOURCE_DIR}" "${_SPHINX_HTML_DIR}")
add_custom_target(html DEPENDS ${_SPHINX_INDEX_HTML})

# for the JSON target, we make everything depend on index.fjson
# JSON documentation is needed for the OST web page.
set(_SPHINX_JSON_DIR "${SHARED_DATA_PATH}/json")
file(MAKE_DIRECTORY ${_SPHINX_JSON_DIR})
set(_SPHINX_INDEX_JSON "${_SPHINX_JSON_DIR}/index.fjson")
add_custom_command(OUTPUT ${_SPHINX_INDEX_JSON}
                   DEPENDS doc_wait_for_rst "${_SPHINX_CONF_PY}" ${_RST_DEPS}
                           ${_DOC_MODULE_DEPS} doc_wait_for_modules
                   COMMAND "${Python_EXECUTABLE}" -m sphinx -b json -c "${_RST_SOURCE_DIR}"
                                     "${_RST_SOURCE_DIR}" "${_SPHINX_JSON_DIR}")
add_custom_target(json DEPENDS ${_SPHINX_INDEX_JSON})

# man target
set(_SPHINX_MAN_DIR "${SHARED_DATA_PATH}/man")
file(MAKE_DIRECTORY ${_SPHINX_MAN_DIR})
set(_SPHINX_MAN "${_SPHINX_MAN_DIR}/promod3.1")
add_custom_command(OUTPUT ${_SPHINX_MAN}
                   DEPENDS doc_wait_for_rst "${_SPHINX_CONF_PY}" ${_RST_DEPS}
                           ${_DOC_MODULE_DEPS} doc_wait_for_modules
                   COMMAND "${Python_EXECUTABLE}" -m sphinx -b man -c "${_RST_SOURCE_DIR}"
                                      "${_RST_SOURCE_DIR}" "${_SPHINX_MAN_DIR}")
add_custom_target(man DEPENDS ${_SPHINX_MAN})

# doc target, registered with all
add_custom_target(doc ALL)
add_dependencies(doc html)
add_dependencies(doc man)

# linkcheck target
set(_SPHINX_LINKCHECK_DIR "${CMAKE_CURRENT_BINARY_DIR}/linkcheck")
file(MAKE_DIRECTORY ${_SPHINX_LINKCHECK_DIR})
add_custom_target(linkcheck
                  COMMAND "${Python_EXECUTABLE}" -m sphinx -b linkcheck -c "${_RST_SOURCE_DIR}"
                                 "${_RST_SOURCE_DIR}" "${_SPHINX_LINKCHECK_DIR}"
                  DEPENDS "${_SPHINX_CONF_PY}" ${_RST_DEPS} ${_DOC_MODULE_DEPS})

# register doctest & linkcheck with check
if(NOT DISABLE_DOCTEST)
  add_dependencies(check doctest)
endif()
if(NOT DISABLE_LINKCHECK)
  add_dependencies(check linkcheck)
endif()

# installing: Since shared data goes to our own sub directory, it is assumed
#             save to just copy over whole directories. This saves us from
#             keeping track of all output files of a html doc tree
#             We install FROM the stage dir tree, since Sphinx will build the
#             documentation right there.
# install html documentation
install(DIRECTORY ${_SPHINX_HTML_DIR} DESTINATION "share/promod3")
# install man pages
install(DIRECTORY ${_SPHINX_MAN_DIR} DESTINATION "share/promod3")

=== extras/CMakeLists.txt ===
# put bash completion in place
# - care for stage directory (etc/bash_completion.d)
# - 'compile' bash completion for pm
# - install

# bash completion file(s)
set(_BC_FILE pm-completion.bash)

# handling bash completion
set(_BC_DIR "${ETC_STAGE_PATH}/bash_completion.d")
set(_ETC_BC_FILE "${_BC_DIR}/${_BC_FILE}")
set(_BC_SUBST_DICT -DINPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${_BC_FILE}.in -DOUT_FILE=${_ETC_BC_FILE} -DPM3_ACTION_NAMES=${PM3_ACTION_NAMES})
add_custom_command(OUTPUT ${_ETC_BC_FILE}
                   MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/CMakeLists.txt"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${_BC_FILE}.in"
                   COMMAND ${CMAKE_COMMAND} ${_BC_SUBST_DICT}
                   -P ${CMAKE_SOURCE_DIR}/cmake_support/substitute.cmake)
add_custom_target(bash-completion ALL DEPENDS ${_ETC_BC_FILE})

=== loop/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(pymod)
add_subdirectory(data)
add_subdirectory(tests)
add_subdirectory(doc)

=== scripts/CMakeLists.txt ===
set(SUBST_DICT OST_ROOT="${OST_ROOT}"
               LIBDIR=${LIB_DIR}
               LIBEXECPATH=${LIBEXEC_PATH}
               PYTHON_MODULE_PATH=${PYTHON_MODULE_PATH}
               OST_PYMOD_PATH=${OST_PYMOD_PATH}
               Python_EXECUTABLE=${Python_EXECUTABLE})

add_custom_target(promod3_scripts ALL)

set(PROMOD3_SCRIPTS pm)

script(NAME pm INPUT pm.in SUBSTITUTE ${SUBST_DICT} 
       TARGET promod3_scripts)

copy_if_different("${CMAKE_CURRENT_BINARY_DIR}" "${STAGE_DIR}/bin"
                  "${PROMOD3_SCRIPTS}" "promod3_scripts" promod3_scripts)

set(_PROMOD3_BUILD_SCRIPTS)
foreach(_pm3_script PROMOD3_SCRIPTS)
  list(APPEND _PROMOD3_BUILD_SCRIPTS ${_pm3_script})
endforeach()

add_dependencies(codetest promod3_scripts)

install(FILES ${PROMOD3_BUILD_SCRIPTS} DESTINATION "bin/")

=== actions/doc/CMakeLists.txt ===
set(ACTION_RST
index.rst
index_dev.rst
)

add_doc_source(NAME actions RST ${ACTION_RST})

=== actions/tests/CMakeLists.txt ===
set(ACTION_UNIT_TESTS
  test_action_build-model.py
  test_action_build-rawmodel.py
  test_action_help.py
  test_actions.py # leave this as last item so it will be executed first!
)

set(ACTION_TEST_DATA
  data/gly.pdb
  data/seq.fasta
  data/seq_ins.fasta
)

promod3_unittest(MODULE actions
  SOURCES "${ACTION_UNIT_TESTS}"
  DATA "${ACTION_TEST_DATA}"
  TARGET actions
)

if(NOT DISABLE_DOCUMENTATION)
  add_doc_dependency(NAME actions
                     DEP "${CMAKE_CURRENT_SOURCE_DIR}/test_actions.py")
endif()

=== cmake_support/doc/CMakeLists.txt ===
set(CMAKE_RST
index.rst
)

add_doc_source(NAME cmake RST ${CMAKE_RST})

=== config/src/CMakeLists.txt ===
# if we need more than one configurational header, add path in front of every
# file via loop!
set(CONFIG_HH_FILE "config.hh")

configure_file(config.hh.in ${CONFIG_HH_FILE})

add_custom_target(config_header)
copy_if_different("${CMAKE_CURRENT_BINARY_DIR}" "${HEADER_STAGE_PATH}/promod3"
                  "${CONFIG_HH_FILE}" "config_headers" config_header)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_HH_FILE} DESTINATION "include/promod3/")

=== core/init/CMakeLists.txt ===
# for translation of __init__.py
set(_CRE_INIT_SUBST_DICT OST_COMPOUNDS_CHEMLIB_PATH="${OST_COMPOUNDS_CHEMLIB_PATH}"
                         OST_ROOT=${OST_ROOT}
                         PROMOD3_VERSION_STRING=${PROMOD3_VERSION_STRING}
                         GIT_BRANCH=${GIT_BRANCH}
                         GIT_COMMIT_HASH=${GIT_COMMIT_HASH})

# top level PM3 init.py (Python only)
pymod(NAME init PY __init__.py TRANSLATE ${_CRE_INIT_SUBST_DICT} END_TRANSLATE
      OUTPUT_DIR "promod3" DEPENDS_ON _core _sidechain _loop _scoring _modelling)

=== core/pymod/CMakeLists.txt ===
# core module
set(CORE_CPP
  export_geom.cc
  export_runtime_profiling.cc
  export_graph_minimizer.cc
  wrap_core.cc
)

set(CORE_PYMOD
  __init__.py
  helper.py
  pm3argparse.py
)

pymod(NAME core CPP ${CORE_CPP} PY ${CORE_PYMOD})

=== debian/changelog ===
promod3 (3.6.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Andrius Merkys <merkys@debian.org>  Thu, 16 Oct 2025 02:50:26 -0400

promod3 (3.6.0+ds-1~exp) experimental; urgency=medium

  * New upstream release 3.6.0+ds.

 -- Andrius Merkys <merkys@debian.org>  Tue, 14 Oct 2025 04:39:50 -0400

promod3 (3.5.0+ds-1~exp) experimental; urgency=medium

  * New upstream release 3.5.0+ds.

 -- Andrius Merkys <merkys@debian.org>  Mon, 26 May 2025 03:50:37 -0400

=== debian/control ===
Source: promod3
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-python-dev,
 libboost-test-dev,
 libeigen3-dev,
 libost-base-dev,
 libost-conop-dev,
 libost-geom-dev,
 libost-img-dev,
 libost-info-dev,
 libost-io-dev,
 libost-mol-alg-dev,
 libost-mol-dev,
 libost-mol-mm-dev,
 libost-seq-alg-dev,
 libost-seq-dev,
 libsqlite3-dev,
 openstructure (>= 2.5.0),
 python3-dev,
 python3-ost,
Standards-Version: 4.5.1
Homepage: https://openstructure.org/promod3/
Vcs-Browser: https://salsa.debian.org/debichem-team/promod3
Vcs-Git: https://salsa.debian.org/debichem-team/promod3.git
Rules-Requires-Root: no

Package: libpromod3-core-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-core3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for ProMod3 core.

Package: libpromod3-core3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for ProMod3 core.

Package: libpromod3-loop-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-loop3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for loop handling engine.

Package: libpromod3-loop3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for loop handling engine.

Package: libpromod3-modelling-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-modelling3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for modelling engine.

Package: libpromod3-modelling3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for modelling engine.

Package: libpromod3-scoring-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-scoring3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for scoring functions.

Package: libpromod3-scoring3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for scoring functions.

Package: libpromod3-sidechain-dev
Section: libdevel
Architecture: any
Depends:
 libpromod3-sidechain3.6 (= ${binary:Version}),
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains development files for sidechain handling.

Package: libpromod3-sidechain3.6
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains the shared library for sidechain handling.

Package: promod3
Architecture: all
Depends:
 python3,
 python3-ost,
 python3-promod3,
 ${python3:Depends},
 ${misc:Depends},
Description: protein homology modelling engine
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.

Package: promod3-data
Architecture: all
Depends:
 ${misc:Depends},
Description: protein homology modelling engine - data files
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains ProMod3 data files.

Package: python3-promod3
Architecture: any
Section: python
Depends:
 openstructure,
 promod3-data,
 python3-ost,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
X-Python3-Version: ${python3:Versions}
Description: protein homology modelling engine - Python 3 package
 ProMod3 is a modelling engine based on the OpenStructure computational
 structural biology framework that can perform all steps required to generate
 a protein model by homology. Its modular design aims at implementing flexible
 modelling pipelines and fast prototyping of novel algorithms.
 .
 This package contains ProMod3 Python 3 package.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DOPTIMIZE=ON -DDISABLE_DOCUMENTATION=ON -DOST_ROOT=/usr -DCOMPOUND_LIB=/var/cache/openstructure/compounds.chemlib

override_dh_auto_test:
	dh_auto_test --no-parallel

execute_after_dh_auto_install:
	mv debian/tmp/usr/bin/pm debian/tmp/usr/bin/promod # See debian/README.Debian

override_dh_install-arch:
	dh_install
	for PKG in core loop modelling scoring sidechain; do \
		dh_install -p libpromod3-$${PKG}-dev usr/include/promod3/$${PKG}; \
		dh_install -p libpromod3-$${PKG}-dev usr/lib/libpromod3_$${PKG}.so   usr/lib/${DEB_HOST_MULTIARCH}; \
		dh_install -p libpromod3-$${PKG}3.6  usr/lib/libpromod3_$${PKG}.so.* usr/lib/${DEB_HOST_MULTIARCH}; \
	done

override_dh_install-indep:
	dh_install
	rm -rf debian/tmp/usr/include/promod3 debian/tmp/usr/lib

=== debian/watch ===
version=4
opts=searchmode=plain,uversionmangle=s/-/~/g,repack,repacksuffix=+ds,dversionmangle=auto \
https://git.scicore.unibas.ch/schwede/ProMod3/-/tags \
 /schwede/ProMod3/-/archive/[^/]+/ProMod3-@ANY_VERSION@@ARCHIVE_EXT@
